//    
// ,     - 
// TState
unit StateUnit;
interface
uses SysUtils, Graphics, AutomataUnit;

  procedure z1;
  procedure z2;
  procedure z3;
  procedure z4;
  procedure z5;
  procedure z11;
  procedure z12;
  procedure z13;
  procedure z21;
  procedure z22;
  procedure z23;
  procedure z31;
  procedure z32;

type
  TState3 = class(TState)
  public
    procedure ProcessSignal(signal: integer); override;
    procedure Enter; override;
  end;

  TGroup1State = class(TState)
  public
    procedure ProcessSignal(signal: integer); override;
  end;

  TState1 = class(TGroup1State)
  public
    procedure ProcessSignal(signal: integer); override;
    procedure Enter; override;
    procedure Exit; override;
  end;

  TState2 = class(TGroup1State)
  public
    procedure ProcessSignal(signal: integer); override;
    procedure Enter; override;
  end;

  TGroup2State = class(TState)
  public
    procedure ProcessSignal(signal: integer); override;
  end;

  TState4 = class(TGroup2State)
  public
    procedure ProcessSignal(signal: integer); override;
    procedure Enter; override;
    procedure Exit; override;
  end;

  TState5 = class(TGroup2State)
  public
    procedure ProcessSignal(signal: integer); override;
    procedure Enter; override;
  end;


implementation
uses MainUnit;


//  ---       --- //

procedure z1;
var
  s: TState;
begin
  Log(ltEnterExit,'..     1 (z1)');
  s:=App.GetRegisteredState(1);
  AppPhoto.WalkTo(s.Left,s.Top);
end;

procedure z2;
var
  s: TState;
begin
  Log(ltEnterExit,'..     2 (z2)');
  s:=App.GetRegisteredState(2);
  AppPhoto.WalkTo(s.Left,s.Top);
end;

procedure z3;
var
  s: TState;
begin
  Log(ltEnterExit,'..     3 (z3)');
  s:=App.GetRegisteredState(3);
  AppPhoto.WalkTo(s.Left,s.Top);
end;

procedure z4;
var
  s: TState;
begin
  Log(ltEnterExit,'..     4 (z4)');
  s:=App.GetRegisteredState(4);
  AppPhoto.WalkTo(s.Left,s.Top);
end;

procedure z5;
var
  s: TState;
begin
  Log(ltEnterExit,'..     5 (z5)');
  s:=App.GetRegisteredState(5);
  AppPhoto.WalkTo(s.Left,s.Top);
end;

procedure z11;
begin
  Log(ltEnterExit,'..  z11 -    ');
  AppPhoto.Size:=0;
end;

procedure z12;
begin
  Log(ltEnterExit,'..  z12 -   ');
  AppPhoto.Size:=0.5;
end;

procedure z13;
begin
  Log(ltEnterExit,'..  z13 -    ');
  AppPhoto.Size:=1;
end;

procedure z21;
begin
  Log(ltEnterExit,'..  z21 -   ');
  AppPhoto.Color:=clYellow;
end;

procedure z22;
begin
  Log(ltEnterExit,'..  z22 -   ');
  AppPhoto.Color:=clWhite;
end;

procedure z23;
begin
  Log(ltEnterExit,'..  z23 -   ');
  AppPhoto.Color:=clLime;
end;

procedure z31;
begin
  Log(ltEnterExit,'..  z31 - " "');
  AppPhoto.Smile:=0;
end;

procedure z32;
begin
  Log(ltEnterExit,'..  z32 - "  "');
  AppPhoto.Smile:=1;
end;


//  ---    3 --- //

procedure TState3.ProcessSignal(signal: integer);
begin
  case signal of
    4: begin
         z32;
         fOwner.SetState(2);
       end;
    else inherited;
  end;
end;

procedure TState3.Enter;
begin
  z3;
end;

//  ---      --- //

procedure TGroup1State.ProcessSignal(signal: integer);
begin
  case signal of
    3: begin
         z31;
         fOwner.SetState(4);
       end;
    else inherited;
  end;
end;

procedure TState1.ProcessSignal(signal: integer);
begin
  case signal of
    1: begin
         ;
         fOwner.SetState(2);
       end;
    else inherited; //    -  1
  end;
end;

procedure TState1.Enter;
begin
  z1;
end;

procedure TState1.Exit;
begin
  z11;
end;

procedure TState2.ProcessSignal(signal: integer);
begin
  case signal of
    1: begin
         ;
         fOwner.SetState(1);
       end;
    2: begin
         z13;
         fOwner.SetState(3);
       end;
    else inherited;  //    -  1
  end;
end;

procedure TState2.Enter;
begin
  z2;
end;


//  ---      --- //

procedure TGroup2State.ProcessSignal(signal: integer);
begin
  case signal of
    2: begin
         z21;
         fOwner.SetState(2);
       end;
    else inherited;
  end;
end;

procedure TState4.ProcessSignal(signal: integer);
begin
  case signal of
    1: begin
         ;
         fOwner.SetState(5);
       end;
    3: begin
         z23;
         fOwner.SetState(3);
       end;
    else inherited;  //    -  2
  end;
end;

procedure TState4.Enter;
begin
  z4;
end;

procedure TState4.Exit;
begin
  z12;
end;

procedure TState5.ProcessSignal(signal: integer);
begin
  case signal of
    4: begin
         z22;
         fOwner.SetState(3);
       end;
    else inherited;  //    -  2
  end;
end;

procedure TState5.Enter;
begin
  z5;
end;

end.
